Require Import VST.floyd.proofauto.
Require Export ASI_surelyMalloc.
Require Import ASI_DFA.

Section ComplementDFA_ASI.
  Variable Sigma: Type.
  Variable Parent: @Dfa Sigma.

  Variable CHrep: Sigma -> val -> Prop.

  (*First guess:
    Definition makeComplement_spec := makeDFA_spec Sigma CHrep ComplementDFA.
    But that's not correct! First, not even the C function types match -- makeComplement takes an input of type State!.
    Second, we need to supply the actual in-memory representation of the parent-DFA in SEP of PRE*)

  Variable DParent: DFA_APD Sigma Parent.
  Variable M:MallocFreeAPD.

  Variable state:type.
  Variable dfaops:type.
  Variable ops i f s:ident.
  Variable cs: compspecs.
  Variable DCompl: DFA_APD Sigma (ComplementDFA Parent).

  Notation ComplemGV:= (DFA_GV _ _ DCompl). (*location predicate for globals*)

  (*note that C code (and this spec) allow invocation of complement irrespective of
    whether the parent DFA is in its inital state, and the resulting DFA simply is in the same state
    as the input DFA*)
  Definition makeComplement_spec : funspec :=
   WITH q:val, st:_, gv: globals
   PRE [ tptr state ]
     PROP (WA+WORD < 100) PARAMS(q) GLOBALS (gv)
     SEP (mem_mgr M gv; ComplemGV gv;
          DFA Sigma CHrep Parent DParent M state dfaops ops i f s cs (st, gv, q))
   POST [ tptr state ]
     EX p: val, PROP () RETURN (p)
        SEP (mem_mgr M gv; ComplemGV gv;
             DFA Sigma CHrep (ComplementDFA Parent) DCompl M state dfaops ops i f s cs (st, gv, p)).

End  ComplementDFA_ASI.
