Require Import VST.floyd.proofauto.
Require Export ASI_surelyMalloc.
Require Import ASI_DFA.

Section IntersectionDFA_ASI.
  Variable charL charR: Type.
  Variable ParentL: @Dfa charL.
  Variable ParentR: @Dfa charR.

  Notation IntersectionDFA := (IntersectionDFA ParentL ParentR).

  Variable CHrepL: charL -> val -> Prop.
  Variable CHrepR: charR -> val -> Prop.

  Variable DParentL: DFA_APD charL ParentL.
  Variable DParentR: DFA_APD charR ParentR.

  Variable M:MallocFreeAPD.

  Variable state:type.
  Variable dfaops:type.
  Variable ops i f s:ident.
  Variable cs: compspecs.

  Variable DInter: DFA_APD _ IntersectionDFA.

  Notation IntersectionGV:= (DFA_GV _ _ DInter). (*location predicate for globals*)
 
  (*note that C code (and this spec) allow invocation of intersection irrespective of
    whether the parent DFAs are in their initial states*)
  Definition makeIntersection_spec : funspec :=
   WITH l:val, r:val, stL:_, stR:_, gv: globals
   PRE [ tptr state, tptr state ]
     PROP (WA+WORD < 100) PARAMS(l;r) GLOBALS (gv)
     SEP (mem_mgr M gv; IntersectionGV gv;
          DFA charL CHrepL ParentL DParentL M state dfaops ops i f s cs (stL, gv, l);
          DFA charR CHrepR ParentR DParentR M state dfaops ops i f s cs (stR, gv, r))
   POST [ tptr state ]
     EX p: val, PROP () RETURN (p)
        SEP (mem_mgr M gv; IntersectionGV gv;
             DFA (charL * charR)%type (fun c v => CHrepL (fst c) v /\ CHrepR (snd c) v) 
                 IntersectionDFA DInter M state dfaops ops i f s cs ((stL, stR), gv, p)).

End IntersectionDFA_ASI.
