Require Import VST.floyd.proofauto.
Require Export DFA.

Notation GVPred := (fun T:Type => T -> globals -> mpred).

Section SingleDFA_specs.
Variable ch:Type.
Variable CHrep: ch -> val -> Prop.

Variable A: @Dfa ch.

Definition single_init_spec (P: GVPred (Dfa_state A)):funspec := 
    WITH s:Dfa_state A, gv: globals
    PRE [ ]
     PROP()
     PARAMS () GLOBALS (gv)
     SEP(P s gv)
    POST[ tvoid ]
      PROP()
      RETURN ()
      SEP(P (Dfa_s A) gv ).

Definition single_final_spec (P: GVPred (Dfa_state A)):funspec := 
    WITH s:Dfa_state A, gv: globals
    PRE [ ]
     PROP()
     PARAMS () GLOBALS (gv)
     SEP(P s gv)
    POST[ tbool ]
      PROP()
      RETURN (if Dfa_fin A s then Vtrue else Vfalse)
      SEP(P s gv).

Definition single_step_spec (P: GVPred (Dfa_state A)):funspec := 
    WITH s:Dfa_state A, gv: globals, c:val, d:ch
    PRE [ tuchar ]
     PROP(CHrep d c)
     PARAMS (c) GLOBALS (gv)
     SEP(P s gv)
    POST[ tvoid ]
      PROP()
      RETURN ()
      SEP(P (@Dfa_trans ch A s d) gv).

Definition SingleDFA_ops_specs:list (GVPred (Dfa_state A) -> funspec):= [single_init_spec; single_final_spec; single_step_spec].

End SingleDFA_specs.

Record SingleDFA_APD (ch:Type) (A: @Dfa ch):= {
  SingleGV: GVPred (Dfa_state A)
}.

Notation CHrep := (fun (b:bool)(v:val) =>
             (b=true <-> (v = Vint (Int.repr 48)))).

