#include "surelyMalloc.h"
#include "ComplementDFA.h"

typedef struct complement {
  struct dfaOps * ops;
  Object parent;
} * Complement;

void complement_init (Object s) { 
  Object o = ((Complement)s) -> parent;
  struct dfaOps * parentOps = o->ops;
  parentOps -> init(o);
  return;
}

bool complement_final (Object s) {
  Object o = ((Complement)s) -> parent;
  struct dfaOps * parentOps = o->ops;
  return (!(parentOps -> final(o)));
}

void complement_step (Object s, uchar c) {
  Object o = ((Complement)s) -> parent;
  struct dfaOps * parentOps = o->ops;
  parentOps -> step(o, c);
}

struct dfaOps complementops = {complement_init, complement_final, complement_step};

Object mkCompl(Object parent) {
  Complement c;
  c = (Complement) surely_malloc (sizeof (struct complement));
  c->ops = &complementops;
  c->parent = parent;
  return ((Object) c);
}
