#include "surelyMalloc.h"
#include "IntersectionDFA.h"

typedef struct intersection {
  struct dfaOps * ops;
  Object left;
  Object right;
} * Intersection;

void intersection_init (Object s) { 
  Object l = ((Intersection)s) -> left;
  struct dfaOps * leftOps = l->ops;
  leftOps -> init(l);

  Object r = ((Intersection)s) -> right;
  struct dfaOps * rightOps = r->ops;
  rightOps -> init(r);

  return;
}

bool intersection_final (Object s) {
  Object l = ((Intersection)s) -> left;
  struct dfaOps * leftOps = l->ops;
  bool bl = leftOps -> final(l);

  Object r = ((Intersection)s) -> right;
  struct dfaOps * rightOps = r->ops;
  bool br = rightOps -> final(r);

  return (bl && br);
}

void intersection_step (Object s, uchar c) {
  Object l = ((Intersection)s) -> left;
  struct dfaOps * leftOps = l->ops;
  leftOps -> step(l, c);
  
  Object r = ((Intersection)s) -> right;
  struct dfaOps * rightOps = r->ops;
  rightOps -> step(r, c);
}

struct dfaOps intersectionops = {intersection_init, intersection_final, intersection_step};

Object make_IntersectionDFA(Object l, Object r) {
  Intersection s;
  s = (Intersection) surely_malloc (sizeof (struct intersection));
  s->ops = &intersectionops;
  s->left = l;
  s->right = r;
  return ((Object) s);
}
