#include "surelyMalloc.h"
#include "ProductDFA.h"

typedef struct product {
  struct dfaOps * ops;
  Object left;
  Object right;
} * Product;

void product_init (Object s) { 
  Object l = ((Product)s) -> left;
  struct dfaOps * leftOps = l->ops;
  leftOps -> init(l);

  Object r = ((Product)s) -> right;
  struct dfaOps * rightOps = r->ops;
  rightOps -> init(r);

  return;
}

bool product_final (Object s) {
  Object l = ((Product)s) -> left;
  struct dfaOps * leftOps = l->ops;
  bool bl = leftOps -> final(l);

  Object r = ((Product)s) -> right;
  struct dfaOps * rightOps = r->ops;
  bool br = rightOps -> final(r);

  return (bl || br);
}

void product_step (Object s, uchar c) {
  Object l = ((Product)s) -> left;
  struct dfaOps * leftOps = l->ops;
  leftOps -> step(l, c);
  
  Object r = ((Product)s) -> right;
  struct dfaOps * rightOps = r->ops;
  rightOps -> step(r, c);
}

struct dfaOps productops = {product_init, product_final, product_step};

Object mkProduct(Object l, Object r) {
  Product s;
  s = (Product) surely_malloc (sizeof (struct product));
  s->ops = &productops;
  s->left = l;
  s->right = r;
  return ((Object) s);
}
