#include "surelyMalloc.h"
#include "T_Weekdays.h"

/*we locally reuse the "days" typdef from weekdays.c*/
typedef struct t_weekdays * days;

struct t_weekdays {
  struct t_dfaOps * ops; /*Share field name 'ops'*/
  enum {Mon, Tue, Wed, Thu, Fri, Sat, Sun} day;
};

/*LATER:*inherit from Weekdays.c
extern void weekday_init (Object); 
extern bool weekday_final (Object);
extern void weekday_step (Object, uchar);
*/

void t_weekday_init (Object s) { 
  ((days)s) -> day = Mon;
  return;
}

bool t_weekday_final (Object s) {
  return (((days)s)->day == Sun);
}

void t_weekday_step (Object s, uchar c) {
  if (c != 'n') { return; }
  switch (((days)s)->day) {
  case Mon: { ((days)s)-> day = Tue; return; }
  case Tue: { ((days)s)-> day = Wed; return; }
  case Wed: { ((days)s)-> day = Thu; return; }
  case Thu: { ((days)s)-> day = Fri; return; }
  case Fri: { ((days)s)-> day = Sat; return; }
  case Sat: { ((days)s)-> day = Sun; return; }
  case Sun: { ((days)s)-> day = Mon; return; }
  default: { return; }
  }
}

void t_weekday_twosteps (Object s, uchar c1, uchar c2) {
  /*We can invoke the locally defined function t_weekday_step*/
  t_weekday_step(s,c1);
  t_weekday_step(s,c2);
  /*But we cannot make a true method call on "this": for example
    ((days)s)->ops->step(s,c2); fails because we don't have access to
    the method table. Only 'recursive objects' (as treated in Esop21) give such access. */
}

struct t_dfaOps t_weekdayops = {t_weekday_init, t_weekday_final, t_weekday_step,  t_weekday_twosteps};

Object make_TWeekdays(void) {
  days s;
  s = (days) surely_malloc (sizeof (struct t_weekdays));
  s->ops = &t_weekdayops;
  s->day = Mon;
  return ((Object) s);
}
