Require Import DFA.
Require Import ZArith.
Require Import Lia.
Require Import compcert.lib.Coqlib.

Open Scope Z.

  Definition TrueFalseDFA := {| Dfa_state := bool; Dfa_s := false;
                                Dfa_fin := id; Dfa_trans := fun _ i : bool => i |}.

   Fixpoint TrueFalseprocess_list (l:list bool) :=
   match l with
     nil => Dfa_s TrueFalseDFA
   | cons h t => Dfa_trans _ (TrueFalseprocess_list t) h
   end.

   Goal forall t h, TrueFalseprocess_list (cons h t) = h.
   Proof. induction t; intros; trivial. Qed.