#include "surelyMalloc.h"
#include "Twice_Weekdays.h"

/*we locally reuse the "days" typdef from weekdays.c*/
typedef struct twc_weekdays * days;

struct twc_weekdays {
  struct t_dfaOps * ops; /*Share field name 'ops'*/
  enum {Mon, Tue, Wed, Thu, Fri, Sat, Sun} day;
};

/*LATER:*inherit from Weekdays.c
extern void weekday_init (Object); 
extern bool weekday_final (Object);
extern void weekday_step (Object, uchar);
*/

void twc_weekday_init (Object s) { 
  ((days)s) -> day = Mon;
  return;
}

bool twc_weekday_final (Object s) {
  return (((days)s)->day == Sun);
}

void twc_weekday_step (Object s, uchar c) {
  if (c != 'n') { return; }
  switch (((days)s)->day) {
  case Mon: { ((days)s)-> day = Tue; return; }
  case Tue: { ((days)s)-> day = Wed; return; }
  case Wed: { ((days)s)-> day = Thu; return; }
  case Thu: { ((days)s)-> day = Fri; return; }
  case Fri: { ((days)s)-> day = Sat; return; }
  case Sat: { ((days)s)-> day = Sun; return; }
  case Sun: { ((days)s)-> day = Mon; return; }
  default: { return; }
  }
}

/*ignores c2, stepping twice using c1 instead*/
void twc_weekday_twice (Object s, uchar c1, uchar c2) {
  /*We can invoke the locally defined function twc_weekday_step*/
  twc_weekday_step(s,c1);
  twc_weekday_step(s,c1);
  /*But we cannot make a true method call on "this": for example
    ((days)s)->ops->step(s,c1); fails because we don't have access to
    the method table. Only 'recursive objects' (as treated in Esop21) give such access. */
}

struct t_dfaOps twc_weekdayops = {twc_weekday_init, twc_weekday_final, twc_weekday_step,  twc_weekday_twice};

Object make_TwiceWeekdays(void) {
  days s;
  s = (days) surely_malloc (sizeof (struct twc_weekdays));
  s->ops = &twc_weekdayops;
  s->day = Mon;
  return ((Object) s);
}
