Require Import VST.floyd.proofauto.

Require Import ASI_surelyMalloc. (*needed for M*)
Require Import VST.floyd.VSU.
Require Import ObjectBase.
Require Import ASI_DFA.
Require Import ASI_EDFA.
Require Import ASI_SingleDFA.
Require Import ASI_StaticDFA.
Require Import WeekdayDFA.
Require Import TrueFalseDFA.
Require Import ASI_TrueFalse.
Require Import ASI_Weekdays.
Require Import ASI_T_Weekdays.
Require Import ASI_Twice_Weekdays.
Require Import ASI_StaticWeekdays.
Require Import ASI_StaticTrueFalse.
Require Import ASI_ComplementDFA.
Require Import ASI_ProductDFA.
Require Import ASI_IntersectionDFA.
Require Import ASI_Client.
Require Import VSU_SingleDFA.
Require Import VSU_TrueFalse.
Require Import VSU_Weekdays.
Require Import VSU_T_Weekdays.
Require Import VSU_Twice_Weekdays.
Require Import VSU_StaticWeekdays.
Require Import VSU_StaticTrueFalse.
Require Import VSU_ComplementDFA.
Require Import VSU_ProductDFA.
Require Import VSU_IntersectionDFA.
(*Require Import VSU_IntersectionInheritDFA.*)
Require Import VSU_Client.
(*
Require Import surelyMalloc.
Require Import spec_surelyMalloc.
Require Import verif_surelyMalloc.*)

Local Instance CompSpecs_ClientTrueFalse: change_composite_env VSU_Client.CompSpecs VSU_TrueFalse.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_TrueFalse.CompSpecs.
Defined.
Local Instance CompSpecs_ClientWeekday: change_composite_env VSU_Client.CompSpecs VSU_Weekdays.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_Weekdays.CompSpecs.
Defined.
Local Instance CompSpecs_ClientStaticWeekday: change_composite_env VSU_Client.CompSpecs VSU_StaticWeekdays.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_StaticWeekdays.CompSpecs.
Defined.
Local Instance CompSpecs_ClientStaticTF: change_composite_env VSU_Client.CompSpecs VSU_StaticTrueFalse.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_StaticTrueFalse.CompSpecs.
Defined.
Local Instance CompSpecs_ClientComplement: change_composite_env VSU_Client.CompSpecs VSU_ComplementDFA.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_ComplementDFA.CompSpecs.
Defined.
Local Instance CompSpecs_ClientProduct: change_composite_env VSU_Client.CompSpecs VSU_ProductDFA.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_ProductDFA.CompSpecs.
Defined.
Local Instance CompSpecs_ClientIntersection: change_composite_env VSU_Client.CompSpecs VSU_IntersectionDFA.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_IntersectionDFA.CompSpecs.
Defined.
(*
Local Instance CompSpecs_ClientInterInherit: change_composite_env VSU_Client.CompSpecs VSU_IntersectionInheritDFA.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_IntersectionInheritDFA.CompSpecs.
Defined.*)
Local Instance CompSpecs_ClientTWeekdays: change_composite_env VSU_Client.CompSpecs VSU_T_Weekdays.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_T_Weekdays.CompSpecs.
Defined.
Local Instance CompSpecs_ClientTwiceWeekdays: change_composite_env VSU_Client.CompSpecs VSU_Twice_Weekdays.CompSpecs.
  make_cs_preserve VSU_Client.CompSpecs VSU_Twice_Weekdays.CompSpecs.
Defined.

Section Application_VSU.
Variable M:MallocFreeAPD.

Definition TF_Weekday_VSU: ltac:(time linkVSUs_Type (Weekday_VSU M) (TrueFalse_VSU M)).
Proof. ltac:(time linkVSUs_Body (Weekday_VSU M) (TrueFalse_VSU M)). Qed.

Definition TFWeekdayComplement_VSU: ltac:(time linkVSUs_Type TF_Weekday_VSU (Complement_VSU _ WeekdayDFA CHrepW WeekdayAPD M)).
Proof. ltac:(time linkVSUs_Body TF_Weekday_VSU (Complement_VSU _ WeekdayDFA CHrepW WeekdayAPD M)). Qed.

Notation ProdCHrep:= (fun (c: ch * ch) (v:val) => CHrepW (fst c) v /\ CHrepW (snd c) v).
Notation PAPD := (ProductAPD ch ch _ _ CHrepW CHrepW WeekdayAPD (ComplementAPD _ WeekdayDFA CHrepW WeekdayAPD M) M). 
Definition PVSU := (Product_VSU ch ch _ _ CHrepW CHrepW WeekdayAPD (ComplementAPD _ WeekdayDFA CHrepW WeekdayAPD M) M).

  Notation InterCHrep:= (fun (c: ch * (ch * ch)) (v:val) => CHrepW (fst c) v /\ ProdCHrep (snd c) v).

  Definition Inter := (IntersectionDFA ch (ch * ch) WeekdayDFA (ProductDFA ch ch WeekdayDFA (ComplementDFA (*ch*) WeekdayDFA))).

  Notation IAPD:= (IntersectionAPD ch (ch * ch) WeekdayDFA (ProductDFA _ _ WeekdayDFA (ComplementDFA (*ch*) WeekdayDFA))
                   CHrepW ProdCHrep WeekdayAPD PAPD M).
  Definition IVSU := (Intersection_VSU ch (ch * ch) WeekdayDFA (ProductDFA ch ch WeekdayDFA (ComplementDFA (*ch*) WeekdayDFA))
                   CHrepW ProdCHrep WeekdayAPD PAPD M).
Definition ProductIntersect_VSU: ltac:(time linkVSUs_Type PVSU IVSU).
Proof. ltac:(time linkVSUs_Body PVSU IVSU). Qed.

Definition TFWeekdayComplementProductIntersect_VSU: ltac:(time linkVSUs_Type TFWeekdayComplement_VSU ProductIntersect_VSU).
Proof. ltac:(time linkVSUs_Body TFWeekdayComplement_VSU ProductIntersect_VSU). Qed.

Definition Statics_VSU: ltac:(time linkVSUs_Type StaticTrueFalse_VSU StaticWeekday_VSU).
Proof. ltac:(time linkVSUs_Body StaticTrueFalse_VSU StaticWeekday_VSU). Qed.

Definition SingleStatics_VSU: ltac:(time linkVSUs_Type SingleTF_VSU Statics_VSU).
Proof. ltac:(time linkVSUs_Body SingleTF_VSU Statics_VSU). Qed.

Definition SingleStaticsComplementProductIntersect_VSU: ltac:(time linkVSUs_Type TFWeekdayComplementProductIntersect_VSU SingleStatics_VSU).
Proof. ltac:(time linkVSUs_Body TFWeekdayComplementProductIntersect_VSU SingleStatics_VSU). Qed.

Definition WithTWeekday_VSU: ltac:(time linkVSUs_Type (TWeekday_VSU M) SingleStaticsComplementProductIntersect_VSU).
Proof. ltac:(time linkVSUs_Body (TWeekday_VSU M) SingleStaticsComplementProductIntersect_VSU). Qed.

Definition WithT_and_TwiceWeekday_VSU: ltac:(time linkVSUs_Type (TwcWeekday_VSU M) WithTWeekday_VSU).
Proof. ltac:(time linkVSUs_Body (TwcWeekday_VSU M) WithTWeekday_VSU). Qed.

Definition Application_VSU: ltac:(time linkVSUs_Type WithT_and_TwiceWeekday_VSU
               (Client_VSU M TrueFalseAPD WeekdayAPD (ComplementAPD _ WeekdayDFA CHrepW WeekdayAPD M) PAPD IAPD 
                           StaticWeekdayAPD StaticTrueFalseAPD SingleTF_APD TWeekdayAPD TwcWeekdayAPD)).
Proof. ltac:(time linkVSUs_Body WithT_and_TwiceWeekday_VSU
               (Client_VSU M TrueFalseAPD WeekdayAPD (ComplementAPD _ WeekdayDFA CHrepW WeekdayAPD M) PAPD IAPD
                           StaticWeekdayAPD StaticTrueFalseAPD SingleTF_APD TWeekdayAPD TwcWeekdayAPD)).
constructor. 
{ (*unfold abbreviate, makeWeekdays_spec, makeDFA_spec.*)
  apply mk_funspec_congr. trivial. trivial. trivial. apply eq_JMeq; trivial.
  apply eq_JMeq. extensionality ts. extensionality gv. apply exp_congr; intros p.
  erewrite (DFA_change_compspecs VSU_Client.CompSpecs VSU_TrueFalse.CompSpecs); try reflexivity.
  intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
constructor. 
{ (*unfold abbreviate, makeWeekdays_spec, makeDFA_spec.*)
  apply mk_funspec_congr. trivial. trivial. trivial. apply eq_JMeq; trivial.
  apply eq_JMeq. extensionality ts. extensionality gv. apply exp_congr; intros p.
  erewrite (DFA_change_compspecs VSU_Client.CompSpecs VSU_Weekdays.CompSpecs); try reflexivity.
  intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
constructor. 
{ (* unfold abbreviate, makeComplement_spec.*)
  apply mk_funspec_congr. trivial. trivial. trivial.
  + apply eq_JMeq. extensionality ts. extensionality x. destruct x as [[q st] gv].
    erewrite (DFA_change_compspecs VSU_Client.CompSpecs VSU_ComplementDFA.CompSpecs); try reflexivity.
    intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction.
  + apply eq_JMeq. extensionality ts. extensionality x. destruct x as [[q st] gv].
    erewrite (DFA_change_compspecs VSU_Client.CompSpecs VSU_ComplementDFA.CompSpecs); try reflexivity.
    intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
constructor. 
{ (*unfold abbreviate, mkUnionspec, mkProductspec, makeProduct_spec.*)
  apply mk_funspec_congr. trivial. trivial. trivial.
  + apply eq_JMeq. extensionality ts. extensionality x. destruct x as [[[[l r] stL] stR] gv].
    erewrite ! (DFA_change_compspecs VSU_Client.CompSpecs VSU_ProductDFA.CompSpecs); try reflexivity.
    - intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction.
    - intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction.
  + apply eq_JMeq. extensionality ts. extensionality x. destruct x as [[[[l r] stL] stR] gv].
    erewrite ! (DFA_change_compspecs VSU_Client.CompSpecs VSU_ProductDFA.CompSpecs); try reflexivity.
    intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
constructor. 
{ (*unfold abbreviate, mkInterspec, mkIntersectionspec, makeIntersection_spec.*)
  apply mk_funspec_congr. trivial. trivial. trivial.
  + apply eq_JMeq. extensionality ts. extensionality x. destruct x as [[[[l r] stL] stR] gv].
    erewrite ! (DFA_change_compspecs VSU_Client.CompSpecs VSU_IntersectionDFA.CompSpecs); try reflexivity.
    - intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction.
    - intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction.
  + apply eq_JMeq. extensionality ts. extensionality x. destruct x as [[[[l r] stL] stR] gv].
    erewrite ! (DFA_change_compspecs VSU_Client.CompSpecs VSU_IntersectionDFA.CompSpecs); try reflexivity.
    intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
constructor.
{ (*unfold abbreviate, makeStaticWeekdays_spec, makeStaticDFA_spec. *)
  apply mk_funspec_congr. trivial. trivial. trivial.
  + apply eq_JMeq. reflexivity.
  + apply eq_JMeq. extensionality ts. extensionality gv.
    erewrite ! (StaticDFA_change_compspecs VSU_Client.CompSpecs VSU_StaticWeekdays.CompSpecs); try reflexivity.
    intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
constructor.
{ (*unfold abbreviate, makeStaticTrueFalse_spec, makeStaticDFA_spec. *)
  apply mk_funspec_congr. trivial. trivial. trivial.
  + apply eq_JMeq. reflexivity.
  + apply eq_JMeq. extensionality ts. extensionality gv.
    erewrite ! (StaticDFA_change_compspecs VSU_Client.CompSpecs VSU_StaticTrueFalse.CompSpecs); try reflexivity.
    intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
constructor.
{ (* unfold abbreviate, make_TWeekdays_spec, makeTDFA_spec. *)
  apply mk_funspec_congr. trivial. trivial. trivial.
  + apply eq_JMeq. reflexivity.
  + apply eq_JMeq. extensionality ts. extensionality gv.
    erewrite ! (EDFA_change_compspecs VSU_Client.CompSpecs VSU_T_Weekdays.CompSpecs); try reflexivity.
    intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
constructor.
{ (*unfold abbreviate, make_TwiceWeekdays_spec, makeTDFA_spec. *)
  apply mk_funspec_congr. trivial. trivial. trivial.
  + apply eq_JMeq. reflexivity.
  + apply eq_JMeq. extensionality ts. extensionality gv.
    erewrite ! (EDFA_change_compspecs VSU_Client.CompSpecs VSU_Twice_Weekdays.CompSpecs); try reflexivity.
    intros j HH. repeat (destruct HH as [| HH]; [ subst j; try reflexivity |]); try contradiction. }
Qed.

(* Definition Application_VSU:=ltac:(linkVSUs CellRecellGcellDcellWrapperClient_VSU (SMVSU M)).*)

End Application_VSU.
Check Application_VSU.
(* Print Assumptions Application_VSU. *)