Require Import VST.floyd.proofauto.
Require Import VST.floyd.VSU.
Require Export ASI_surelyMalloc.
Require Import ObjectBase.
Require Import ASI_DFA.
Require Import TrueFalseDFA.
Require Import ASI_TrueFalse.

Require Import TrueFalseV.

Local Instance CompSpecs : compspecs. make_compspecs prog. Defined.
Definition truefalseQP:= ltac:(QPprog prog).
Definition truefalseVprog := QPvarspecs truefalseQP.
Notation state := (Tstruct _state noattr).
Notation tfvstate := (Tstruct _tfv_state noattr).
Notation dfaops := (Tstruct _dfaOps noattr).

Section TrueFalseV_VSU.
  Variable M: MallocFreeAPD.
(*
  Definition TrueFalseV_Inv: GPred (Dfa_state TrueFalseDFA) := fun x =>
   match x with (d, gv, v) =>
   withspacer Ews (sizeof size_t + sizeof tbool) (2 * sizeof size_t)
     (fun u => field_at Ews tfvstate [StructField _tfv] (Val.of_bool d) (offset_val (-4) u)) v
   end.
*)

  Definition TrueFalseV_Inv: GPred (Dfa_state TrueFalseDFA) := fun x =>
   match x with (d, gv, v) =>
     !!(isptr v) && field_at Ews tfvstate [StructField _tfv] (Val.of_bool d) (offset_val (-(sizeof (Tpointer tfvstate noattr))) v)
   end.

  Definition tfv_specs:= DFA_ops_specs state bool CHrep TrueFalseDFA.

  Definition TrueFalseVMT (i f s:val): val -> GPred (Dfa_state TrueFalseDFA) -> mpred :=
    MTable (Dfa_state TrueFalseDFA) dfaops [_init; _final; _step] tfv_specs [i;f;s].

  Lemma TrueFalseVMT_duplicable i f s m P: TrueFalseVMT i f s m P |-- TrueFalseVMT i f s m P * TrueFalseVMT i f s m P.
  Proof. apply funcptrs_duplicable. Qed.

  Lemma make_TrueFalseVMT:
  forall sh1 sh2 sh3 i f s m, readable_share sh1 -> readable_share sh2 -> readable_share sh3 ->
  (func_ptr' (init_spec state bool TrueFalseDFA TrueFalseV_Inv) i *
   func_ptr' (final_spec state bool TrueFalseDFA TrueFalseV_Inv) f *
   func_ptr' (step_spec state bool CHrep TrueFalseDFA TrueFalseV_Inv) s *
   field_at sh1 dfaops [StructField _init] i m *
   field_at sh2 dfaops [StructField _final] f m *
   field_at sh3 dfaops [StructField _step] s m
  |-- TrueFalseVMT i f s m TrueFalseV_Inv)%logic.
  Proof. intros. unfold TrueFalseVMT. simpl. Exists sh1 i sh2 f sh3 s. entailer!. Qed.
(*
  Lemma verif_init_aux: semax_body truefalseVprog nil f_tfv_init (_tfv_init, init_spec state bool _ TrueFalseV_Inv).
  Proof.
    start_function. unfold TrueFalseV_Inv; unfold withspacer; simpl; Intros.
    destruct v; inv Pv.
    forward. simpl.
    assert_PROP (field_compatible tfvstate (DOT _tfv) (Vptr b (Ptrofs.add i (Ptrofs.repr (-8))))) as FCs by entailer!.
    rewrite Ptrofs.of_int64_to_int64 by reflexivity. (*64bit*)
     Search Ptrofs.of_int64 .

specialize (field_address_offset _ _ _ FCs). simpl; rewrite ptrofs_add_repr_0_r; intros.
rewrite <- H.
     unfold field_address; simpl. rewrite if_true, ptrofs_add_repr_0_r by trivial.
 forward.
    unfold offset_val. forward.
    assert_PROP ((Vptr b
   (Ptrofs.sub i  (Ptrofs.repr 8))) = field_address tfvstate [StructField _tfv] (offset_val (-(sizeof (Tpointer tfvstate noattr))) (Vptr b i))).
    { entailer!. unfold field_address; simpl. rewrite if_true, ptrofs_add_repr_0_r, Ptrofs.sub_add_opp by trivial.
      f_equal. }
    unfold offset_val.
    replace (Ptrofs.add i (Ptrofs.repr (-8))) with (Ptrofs.sub i (Ptrofs.repr 8)).
    2:{  rewrite Ptrofs.sub_add_opp. reflexivity. } 
    rewrite H.  simpl. unfold field_address. simpl. rewrite if_true. forward. f_equal. rewrite Ptrofs.neg_mul_distr_l.
      replace (Ptrofs.of_int64 (Int64.repr 8)) with Ptrofs.one.
      + rewrite Ptrofs.mul_one. reflexivity.
      + unfold Ptrofs.of_int64, Ptrofs.one.
        rewrite Int64.unsigned_repr.
Search Int64.repr Ptrofs.repr. Search Ptrofs.one.  Search Ptrofs.sub. rewrite Ptrofs.add_O_r. rep_lia.
      2:{ trivial. Search Ptrofs.sub.
assert_PROP((Vptr b
   (Ptrofs.sub i
      (Ptrofs.mul (Ptrofs.repr 8)
         (Ptrofs.of_int64 (Ptrofs.to_int64 (Ptrofs.repr 8))))) =
   field_address tfvstate [StructField _tfv] (offset_val (-4) (Vptr b i)).

Vptr b
   (Ptrofs.add
      (Ptrofs.sub i
         (Ptrofs.mul (Ptrofs.repr 8)
            (Ptrofs.of_int64 (Ptrofs.to_int64 (Ptrofs.repr 8)))))
      (Ptrofs.repr 0)) = field_address tfvstate [StructField _tfv] (offset_val (-4) (Vptr b i))).
    { entailer!. unfold field_address; simpl. rewrite if_true, ptrofs_add_repr_0_r, Ptrofs.sub_add_opp by trivial.
      f_equal. f_equal. Search Ptrofs.mul.  Search Ptrofs.sub. rewrite Ptrofs.add_O_r. rep_lia.
      2:{ trivial. Search Ptrofs.sub.
Search Ptrofs.of_int64 Int64.repr.  forward. hint.
    unfold offset_val. normalize.
 forward. unfold spacer. simpl. unfold at_offset. simpl. forward.
Check field_compatible 
    forward. entailer!; simpl. unfold withspacer; simpl. cancel.
  Qed. 
  Lemma verif_final_aux: semax_body truefalseVprog nil f_tfv_final (_tfv_final, final_spec state bool _ TrueFalseV_Inv).
  Proof.
    start_function. unfold TrueFalseV_Inv, withspacer; simpl; Intros.
    forward. destruct s; entailer!. forward.
  Qed.
  Lemma verif_step_aux: semax_body truefalseVprog nil f_tfv_step (_tfv_step, step_spec state bool CHrep _ TrueFalseV_Inv).
  Proof. unfold step_spec.
     start_function. rename H into Hcd.
     unfold TrueFalseV_Inv, withspacer; simpl; Intros.
     forward. entailer!. clear - Hcd. simpl. unfold withspacer, Val.of_bool; simpl; cancel.
     apply derives_refl'. f_equal. destruct Hcd.
     remember (Int.eq c (Int.repr 48)) as b; symmetry in Heqb; destruct b; simpl.
     + apply int_eq_e in Heqb; subst c. rewrite H0; trivial.
     + destruct d; [ | reflexivity].
       specialize (H (eq_refl _)); inv H. rewrite Int.eq_true in Heqb; discriminate.
  Qed.
*)
  Definition TrueFalseVGV (gv:globals): mpred :=
           EX sh1 sh2 sh3, !!(readable_share sh1 /\ readable_share sh2 /\ readable_share sh3) &&
                               (field_at sh1 dfaops (DOT _init)  (gv _tfv_init)  (gv _tfvops) *
                                field_at sh2 dfaops (DOT _final) (gv _tfv_final) (gv _tfvops) *
                                field_at sh3 dfaops (DOT _step)  (gv _tfv_step)  (gv _tfvops)).

  Lemma TrueFalseV_Inv_isptrnull a v: TrueFalseV_Inv (a, v) |-- !! is_pointer_or_null v.
  Proof. unfold TrueFalseV_Inv, withspacer; destruct a; simpl; entailer!. Qed.

  Definition TrueFalseVAPD:= Build_DFA_APD bool TrueFalseDFA TrueFalseVGV TrueFalseV_Inv. (*TrueFalseV_Inv_isptrnull*)

  Notation mkTFVspec := (makeTrueFalse_spec TrueFalseVAPD M state dfaops _ops _init _final _step CompSpecs).

  Definition TrueFalseV_internalspecs := [(_tfv_init, init_spec state bool _ TrueFalseV_Inv);
                                       (_tfv_final, final_spec state bool _ TrueFalseV_Inv);
                                       (_tfv_step, step_spec state bool CHrep _ TrueFalseV_Inv);
                                       (_make_TrueFalseV, mkTFVspec)]. 

  Definition TrueFalseV_Gprog : funspecs := TrueFalseV_internalspecs ++ [(_surely_malloc, surely_malloc_numericspec M)].
  (* SM_ASI free surelyMalloc.*)

  Lemma align_compatible_tfvstate {b i} (AL: align_compatible tfvstate (Vptr b i)):
        align_compatible state (Vptr b i).
  Proof. inv AL. inv H. inv H1. 
      eapply align_compatible_rec_Tstruct; [reflexivity |].
      simpl co_members in *; intros. specialize (H3 i0).
      simpl in H.
      if_tac in H.
      { inv H. specialize (H3 _ _ (eq_refl _) (eq_refl _)).
        eapply align_compatible_rec_by_value. reflexivity.
        inv H0. inv H3. inv H. simpl in *. rewrite Z.add_comm in H0. 
        apply Z.divide_add_cancel_r in H0. rewrite Zplus_0_r; apply H0. exists 1; trivial. }
      clear H1. congruence.
  Qed.

  Lemma field_compatible_tfvstate_ops p: field_compatible tfvstate [StructField _ops] p ->
        field_compatible state [StructField _ops] p.
  Proof. intros.
    destruct H as [Pt [COMPL [SZ [AL LNF]]]].
    destruct p; inv Pt. split3; try reflexivity.
    split3.
    - red; simpl. red in SZ; simpl in SZ. lia.
    - clear - AL. apply align_compatible_tfvstate; trivial.
    - split; simpl; auto. left; trivial.
  Qed.

  Lemma TrueFalseV_GP gv (GV: globals_ok gv):
        InitGPred (Vardefs truefalseQP) gv |-- TrueFalseVGV gv.
  Proof. unfold Vardefs. unfold InitGPred, TrueFalseVGV. Exists Ews Ews Ews.
    assert (X: filter isGvar (Maps.PTree.elements (QP.prog_defs truefalseQP)) = [(_tfvops, Gvar v_tfvops)]) by reflexivity.
    rewrite X; clear X.
    simpl; Intros. rewrite sepcon_emp.
    unfold globvar2pred; simpl; entailer.
    erewrite <- 3 mapsto_field_at; try reflexivity; auto with field_compatible.
    rewrite ! sepcon_assoc. 
    apply sepcon_derives; [ | apply sepcon_derives]; simpl.
    - unfold field_address. simpl. rewrite if_true by (auto with field_compatible).
      destruct (GV  _tfv_init) as [G | G].
      + destruct G as [g G]; rewrite G. entailer.
      + rewrite G. entailer.
    - unfold field_address. simpl. rewrite if_true by (auto with field_compatible).
      destruct (GV  _tfv_final) as [G | G].
      + destruct G as [g G]; rewrite G. entailer.
      + rewrite G. entailer.
    - unfold field_address. simpl. rewrite if_true by (auto with field_compatible).
      destruct (GV  _tfv_step) as [G | G].
      + destruct G as [g G]; rewrite G. entailer.
      + rewrite G. entailer.
  Qed.

Opaque funcptrs.

  Lemma body_makeTrueFalseV: semax_body truefalseVprog TrueFalseV_Gprog f_make_TrueFalseV  (_make_TrueFalseV, mkTFVspec).
  Proof.
  unfold mkTFVspec, makeTrueFalse_spec, makeDFA_spec, TrueFalseVGV. function_pointers.
  start_function. rename H into HWW.
  forward_call surelymalloc_spec_sub (tfvstate, gv). { simpl. rep_lia. }
  Intros s.
  make_func_ptr _tfv_init.
  make_func_ptr _tfv_final.
  make_func_ptr _tfv_step.
  unfold TrueFalseVAPD, TrueFalseVGV. simpl. Intros ish fsh ssh. rename H into Hish. rename H0 into Hfsh. rename H1 into Hssh.
 
  sep_apply(make_TrueFalseVMT ish fsh ssh (gv _tfv_init) (gv _tfv_final) (gv _tfv_step) (gv _tfvops) Hish Hfsh Hssh).
  forward. forward.
  sep_apply TrueFalseVMT_duplicable; Intros. forward.
  Exists (offset_val 8 s). entailer!.
  rewrite 2 sepcon_assoc. apply sepcon_derives.
  { unfold DFA_GV. simpl. unfold TrueFalseVMT. simpl.
    Transparent funcptrs. unfold MTable. Opaque funcptrs. simpl.
    Intros Ish gi Fsh gf Ssh gs. Exists Ish Fsh Ssh. entailer!.
    do 3 sep_apply func_ptr'_emp. cancel.
    apply JMeq_eq in H2. subst gi. 
    apply JMeq_eq in H4. subst gf. 
    apply JMeq_eq in H6. subst gs. cancel. }
  rewrite DFA_fold_unfold. 
  Exists [gv _tfv_init; gv _tfv_final; gv _tfv_step]. 
    Exists (CompSpecs, tfvstate) (gv _tfvops). simpl.
    entailer!. assert (malloc_token M Ews tfvstate s = malloc_token M Ews tfvstate (offset_val 8 s)).
    {  unfold malloc_token. simpl.  admit. } rewrite H2. cancel.
    rewrite sepcon_comm. apply sepcon_derives. 2: apply derives_refl.
    unfold withspacer; simpl.
    unfold_data_at (data_at Ews tfvstate _ s). cancel.
    unfold FldAt. simpl. Exists (gv _tfvops); entailer!.
   apply field_compatible_tfvstate_ops in H5.
    unfold field_at. simpl; entailer!. admit.
simpl.
  Qed.

  Lemma verif_init: semax_body truefalseVprog TrueFalseV_Gprog f_tf_init (_tf_init, init_spec state bool _ TrueFalseV_Inv).
  Proof. apply semax_body_subsumespec_GprogNil. apply verif_init_aux. LNR_tac. Qed.

  Lemma verif_final: semax_body truefalseVprog TrueFalseV_Gprog f_tf_final (_tf_final, final_spec state bool _ TrueFalseV_Inv).
  Proof. apply semax_body_subsumespec_GprogNil. apply verif_final_aux. LNR_tac. Qed.

  Lemma verif_step: semax_body truefalseVprog TrueFalseV_Gprog f_tf_step (_tf_step, step_spec state bool CHrep _ TrueFalseV_Inv).
  Proof. apply semax_body_subsumespec_GprogNil. apply verif_step_aux. LNR_tac. Qed.


  (*For now, we only export the constructor. If later "subclasses" inherit init, final, or step, well need to export these here, too*)
  Definition TrueFalseV_VSU: @VSU NullExtension.Espec nil [(_surely_malloc, surely_malloc_numericspec M)] truefalseQP 
             [ (_make_TrueFalseV,mkTFspec)]
             TrueFalseVGV.
  Proof.
     mkVSU prog TrueFalseV_internalspecs.
     - solve_SF_internal verif_init.
     - solve_SF_internal verif_final.
     - solve_SF_internal verif_step.
     - solve_SF_internal body_makeTrueFalseV.
     - apply TrueFalseV_GP.
  Qed.

End TrueFalseV_VSU.