Require Import DFA.
Require Import ZArith.
Require Import Lia.

Open Scope Z.

  Notation ch := {n:Z | 0<= n < 256}.

  Definition Weekday := { z:Z | 0<=z<7 }.
  Program Definition Monday:Weekday := @exist Z (fun z => 0<=z<7) 0 _. Next Obligation. lia. Qed.
  Program Definition Tuesday:Weekday := @exist Z (fun z => 0<=z<7) 1 _. Next Obligation. lia. Qed.
  Program Definition Wednesday:Weekday := @exist Z (fun z => 0<=z<7) 2 _. Next Obligation. lia. Qed.
  Program Definition Thursday:Weekday := @exist Z (fun z => 0<=z<7) 3 _. Next Obligation. lia. Qed.
  Program Definition Friday:Weekday := @exist Z (fun z => 0<=z<7) 4 _. Next Obligation. lia. Qed.
  Program Definition Saturday:Weekday := @exist Z (fun z => 0<=z<7) 5 _. Next Obligation. lia. Qed.
  Program Definition Sunday:Weekday := @exist Z (fun z => 0<=z<7) 6 _. Next Obligation. lia. Qed.

  Definition WeekdayDFA:@Dfa ch.
   apply (@Build_Dfa ch _ Monday).
   + intros d. apply (Z.eqb (proj1_sig d) (proj1_sig Sunday)).
   + intros day char.
     apply (if (Z.eqb (Z.of_nat (Byte.to_nat "n")) (proj1_sig char))
     then if Z.eqb (proj1_sig day) (proj1_sig Monday) then Tuesday else
          if Z.eqb (proj1_sig day) (proj1_sig Tuesday) then Wednesday else
          if Z.eqb (proj1_sig day) (proj1_sig Wednesday) then Thursday else
          if Z.eqb (proj1_sig day) (proj1_sig Thursday) then Friday else
          if Z.eqb (proj1_sig day) (proj1_sig Friday) then Saturday else
          if Z.eqb (proj1_sig day) (proj1_sig Saturday) then Sunday else
          Monday
    else day).
   Defined.