#include "surelyMalloc.h"
#include "Weekdays.h"

typedef struct weekdays * days;

struct weekdays {
  struct dfaOps * ops;
  enum {Mon, Tue, Wed, Thu, Fri, Sat, Sun} day;
};

void weekday_init (Object s) { 
  ((days)s) -> day = Mon;
  return;
}

bool weekday_final (Object s) {
  return (((days)s)->day == Sun);
}

void weekday_step (Object s, uchar c) {
  if (c != 'n') { return; }
  switch (((days)s)->day) {
  case Mon: { ((days)s)-> day = Tue; return; }
  case Tue: { ((days)s)-> day = Wed; return; }
  case Wed: { ((days)s)-> day = Thu; return; }
  case Thu: { ((days)s)-> day = Fri; return; }
  case Fri: { ((days)s)-> day = Sat; return; }
  case Sat: { ((days)s)-> day = Sun; return; }
  case Sun: { ((days)s)-> day = Mon; return; }
  default: { return; }
  }
}

struct dfaOps weekdayops = {weekday_init, weekday_final, weekday_step};

Object make_Weekdays(void) {
  days s;
  s = (days) surely_malloc (sizeof (struct weekdays));
  s->ops = &weekdayops;
  s->day = Mon; /*go to initial state*/
  return ((Object) s);
}
